--- nautilus-3.1.3/libnautilus-private/nautilus-file.c.orig	2011-07-22 15:55:37.274869941 +0100
+++ nautilus-3.1.3/libnautilus-private/nautilus-file.c	2011-07-22 16:05:34.306574660 +0100
@@ -47,6 +47,7 @@
 #include "nautilus-vfs-file.h"
 #include "nautilus-saved-search-file.h"
 #include "nautilus-lockdown.h"
+#include "nautilus-zfs.h"
 #include <eel/eel-debug.h>
 #include <eel/eel-glib-extensions.h>
 #include <eel/eel-gtk-extensions.h>
@@ -142,7 +143,8 @@
 	attribute_where_q,
 	attribute_link_target_q,
 	attribute_volume_q,
-	attribute_free_space_q;
+	attribute_free_space_q,
+	attribute_restore_info_q;
 
 static void     nautilus_file_info_iface_init                (NautilusFileInfoIface *iface);
 static char *   nautilus_file_get_owner_as_string            (NautilusFile          *file,
@@ -152,6 +154,7 @@
 							      GFileInfo             *info);
 static const char * nautilus_file_peek_display_name (NautilusFile *file);
 static const char * nautilus_file_peek_display_name_collation_key (NautilusFile *file);
+static void invalidate_restore_info (NautilusFile *file);
 static void file_mount_unmounted (GMount *mount,  gpointer data);
 static void metadata_hash_free (GHashTable *hash);
 
@@ -486,7 +489,14 @@
 
 	eel_ref_str_unref (file->details->filesystem_id);
 	file->details->filesystem_id = NULL;
-
+        g_free (file->details->restore_info);
+        file->details->restore_info = NULL;
+        invalidate_restore_info (file);
+        g_free (file->details->snapshot_directory);
+        file->details->snapshot_directory = NULL;
+        file->details->has_snap_versions_in_progress = FALSE;
+        file->details->has_snap_versions_is_up_to_date = FALSE;
+        file->details->has_snap_versions = FALSE;
 	clear_metadata (file);
 }
 
@@ -804,6 +814,10 @@
 	g_free (file->details->activation_uri);
 	g_clear_object (&file->details->custom_icon);
 
+	g_free (file->details->restore_info);
+	if (file->details->snapshot_directory)
+		g_free (file->details->snapshot_directory);
+
 	if (file->details->thumbnail) {
 		g_object_unref (file->details->thumbnail);
 	}
@@ -4423,6 +4437,76 @@
 	NULL
 };
 
+char *
+nautilus_date_as_string (time_t time_raw, gboolean use_smallest)
+{
+	struct tm *ttime;
+	const char **formats;
+	const char *width_template;
+	const char *format;
+	char *date_string;
+	char *result;
+	GDate *today;
+	GDate *date;
+	guint32 date_age;
+	int i, date_format_pref;
+
+	ttime = localtime (&time_raw);
+
+	if (!use_smallest)
+	  {
+	    date_format_pref = g_settings_get_enum (nautilus_preferences,
+						NAUTILUS_PREFERENCES_DATE_FORMAT);
+	    if (date_format_pref == NAUTILUS_DATE_FORMAT_LOCALE) {
+	      return eel_strdup_strftime ("%c", ttime);
+	    } else if (date_format_pref == NAUTILUS_DATE_FORMAT_ISO) {
+	      return eel_strdup_strftime ("%Y-%m-%d %H:%M:%S",ttime);
+	    }
+	  }
+	
+	date = eel_g_date_new_tm (ttime);
+	
+	today = g_date_new ();
+	g_date_set_time_t (today, time (NULL));
+
+	/* Overflow results in a large number; fine for our purposes. */
+	date_age = (g_date_get_julian (today) -
+			 g_date_get_julian (date));
+
+	g_date_free (date);
+	g_date_free (today);
+
+	/* Format varies depending on how old the date is. This minimizes
+	 * the length (and thus clutter & complication) of typical dates
+	 * while providing sufficient detail for recent dates to make
+	 * them maximally understandable at a glance. Keep all format
+	 * strings separate rather than combining bits & pieces for
+	 * internationalization's sake.
+	 */
+
+	if (date_age == 0)	{
+		formats = TODAY_TIME_FORMATS;
+	} else if (date_age == 1) {
+		formats = YESTERDAY_TIME_FORMATS;
+	} else if (date_age < 7) {
+		formats = CURRENT_WEEK_TIME_FORMATS;
+	} else {
+		formats = CURRENT_WEEK_TIME_FORMATS;
+	}
+
+
+	if (!use_smallest)
+	  format = _(formats[1]);
+	else
+	  {
+	    int i=0; 
+	    while (formats[i] != NULL) 
+	      i++;
+	    format = _(formats[i-3]);
+	  }
+	return eel_strdup_strftime (format, ttime);
+}
+
 static char *
 nautilus_file_fit_date_as_string (NautilusFile *file,
 				  NautilusDateType date_type,
@@ -6103,7 +6187,9 @@
 	if (attribute_q == attribute_free_space_q) {
 		return nautilus_file_get_volume_free_space (file);
 	}
-
+	if (attribute_q == attribute_restore_info_q) {
+		return nautilus_file_get_restore_info_async (file);
+	}
 	extension_attribute = NULL;
 	
 	if (file->details->pending_extension_attributes) {
@@ -7037,6 +7123,616 @@
 
 }
 
+gboolean                
+nautilus_file_is_in_snapshot (NautilusFile *file)
+{
+  char *file_uri = nautilus_file_get_uri (file);
+  gboolean result = ts_is_in_snapshot (file_uri);
+  g_free (file_uri);
+  return result;
+}
+
+static gboolean nautilus_file_in_snap_exist_in_current (NautilusFile *file, GCancellable *cancel)
+{
+  /* get path without /.zfs/snapshot/blah/ */
+  /* test is file exist */
+  char *file_uri = nautilus_file_get_uri (file);
+  char *file_uri_without_snap = NULL;
+  gboolean result = FALSE;
+
+  if (g_cancellable_is_cancelled (cancel))
+    {
+      g_free (file_uri);
+      return FALSE;
+    }
+
+  file_uri_without_snap = ts_remove_snapshot_dir (file_uri);
+
+  if (file_uri_without_snap)
+    {
+      GFile* root_file = g_file_new_for_uri (file_uri_without_snap);
+      char *path = g_file_get_path (root_file);
+	  
+      if (path)
+	{
+	  result =  g_file_test (path, G_FILE_TEST_EXISTS);
+	  g_free (path);
+	}
+      g_object_unref (root_file);
+      g_free (file_uri_without_snap);
+
+    }
+  
+  g_free (file_uri);
+
+  return result;
+}
+
+
+char * nautilus_file_in_snapshot_get_info (NautilusFile *file, GCancellable *cancel)
+{
+  char *info = NULL;
+  GFile *then_gfile = nautilus_file_get_location (file);
+  char *then_path = g_file_get_path (then_gfile);
+  g_object_unref (then_gfile);
+
+  if (g_cancellable_is_cancelled (cancel))
+    {
+      g_free (then_gfile);
+      g_free (then_path);
+      return g_strdup ("cancelled");
+    }
+  if (then_path)
+    {
+      struct stat64 now;
+      struct stat64 then;
+      char *now_path = ts_remove_snapshot_dir (then_path);
+
+      if (lstat64 (now_path, &now) == 0)
+	{
+	  if (lstat64 (then_path, &then) == 0)
+	    {
+
+	      if (now.st_mtime != then.st_mtime)
+		{
+		  if (now.st_size == then.st_size)
+		    /* SUN_BRANDING */
+		    info = g_strdup (_("different date, same size as latest version"));
+		  else if (now.st_size > then.st_size)
+		    /* SUN_BRANDING */
+		    info = g_strdup (_("different date, smaller than latest version"));
+		  else if ( now.st_size < then.st_size)
+		    /* SUN_BRANDING */
+		    info = g_strdup (_("different date, bigger than latest version"));
+		}
+	      else
+		/* SUN_BRANDING */
+		info = g_strdup (_("identical to latest version"));
+	    }
+	  else
+	    info = g_strdup_printf ("FIXME no then %s", then_path);
+	}
+      else
+	/* SUN_BRANDING */
+	info = g_strdup (_("not present in latest version"));
+
+      g_free (now_path);
+      g_free (then_path);
+    }
+
+  return info;
+}
+
+static char * restore_string (char *str, GCancellable *cancel)
+{
+  if (g_cancellable_is_cancelled (cancel))
+    {
+      g_free (str);
+      return g_strdup (_("unknown"));
+    }
+  else
+    return str;
+}
+
+gint time_cmp (time_t *a,
+	       time_t *b)
+{
+  if (*a == *b)
+    return 0;
+  if (*a > *b)
+    return 1;
+  if (*a < *b)
+    return -1;
+
+}
+
+char *			
+nautilus_file_get_num_snapshot_version (NautilusFile *file, 
+                                        GCancellable *cancel,
+                                        gboolean stop_at_first)
+{
+  GList *tmp = NULL;
+  GList *tmp2 = NULL;
+  GList *time = NULL;
+  time_t* now_time = NULL;
+  char *result = NULL;
+  int version = 0;
+  NautilusFile *parent = NULL;
+  NautilusDirectory *dir = NULL;
+  char *snapdir = NULL;
+
+  if (NAUTILUS_IS_FILE (file))
+    {
+      parent = nautilus_file_get_parent (file);
+      if (parent)
+	{
+	  dir = nautilus_directory_get_for_file (parent);
+	  g_object_unref (parent);
+	}
+    }
+  if (dir)
+    {
+      struct stat64 now;
+      struct stat64 then;
+      char snap_name[PATH_MAX+1];
+      char *name = nautilus_file_get_name (file);
+      
+      g_object_ref (dir);
+      tmp = nautilus_directory_get_snapshots (dir);
+      
+      GFile *now_gfile = nautilus_file_get_location (file);
+      char *now_path = g_file_get_path (now_gfile);
+      g_object_unref (now_gfile);
+
+      if (now_path)
+	{
+	  if (lstat64 (now_path, &now) != 0)
+	    {
+	      g_free (now_path);
+	      g_object_unref (dir);
+	      return NULL;
+	    }
+	}
+      
+      g_free (now_path);
+
+      time = NULL;
+
+      /* get list of mtime for all files in snapshots */
+
+      now_time = g_new0 (time_t, 1);
+      *now_time = now.st_mtim.tv_sec;
+      time = g_list_prepend (time, now_time);
+
+
+      for (tmp; tmp; tmp = tmp->next)
+	{
+	  g_sprintf (snap_name, "%s/%s", 
+		     ((ZfsDataSet *) tmp->data)->mountpoint, 
+		     name);
+	  if (g_cancellable_is_cancelled (cancel))
+	    goto cancel;
+	  if (lstat64 (snap_name, &then) == 0)
+	    {
+	      if (g_list_find_custom (time, &then.st_mtim.tv_sec, (GCompareFunc) time_cmp) == NULL)
+		{ /*insert in list only is unique */
+		  time_t* snap_time = g_new0 (time_t, 1);
+		  *snap_time = then.st_mtim.tv_sec;
+		  time = g_list_prepend (time, snap_time);
+                  if (stop_at_first)
+                    {
+                      snapdir = g_strdup (((ZfsDataSet *) tmp->data)->mountpoint);
+                      goto cancel;
+                    }
+		}
+	    }
+
+	}
+cancel:
+      g_free (name);
+      g_object_unref (dir);
+    }
+
+
+  for (tmp = time; tmp; tmp = tmp->next)
+    {
+      g_free ((time_t*) tmp->data);
+      version++;
+    }
+
+  /* remove current version */
+  version--;
+
+  g_list_free (time);
+
+  if (version == 0)
+    {
+      if (stop_at_first)
+        return NULL;
+      else /*SUN_BRANDING*/
+        return restore_string (g_strdup_printf (_("no other version")), cancel);
+    }
+
+  if (stop_at_first)
+    return snapdir;
+  else
+    return restore_string (g_strdup_printf ("%d %s", version,
+                                            /* SUN_BRANDING */
+                                            version > 1 ? _("other versions") : /* SUN_BRANDING */ _("other version")),
+                           cancel);
+}
+
+static gboolean worker_thread_started = FALSE;
+
+typedef void (*ReadyCallback) (gpointer		  data,
+			       GCancellable      *cancellable);
+typedef void (*WorkerFunction) (gpointer		  data,
+			       GCancellable      *cancellable);
+typedef struct {
+  gpointer	    data;
+  gpointer	    return_data;
+  ReadyCallback	    ready_callback;
+  WorkerFunction    worker_func;
+  GCancellable	    *cancellable;
+} QueryData;
+
+static void 		
+nautilus_file_get_restore_info (gpointer data,
+				GCancellable       *cancellable)
+{
+  QueryData *qdata = (QueryData*) data;
+  NautilusFile *file = NAUTILUS_FILE (qdata->data);
+  char *result = NULL;
+
+  /*{
+    struct timespec ts;
+    ts.tv_sec = 1;
+    ts.tv_nsec = 0;
+    nanosleep (&ts, NULL);
+  }
+
+    {
+      GFile *f = nautilus_file_get_location (file);
+      char *path = g_file_get_uri (f);
+      printf ("start restore info for %s", path);
+      g_free (path);
+      g_object_unref (f);
+    }*/
+  if (!g_cancellable_is_cancelled (cancellable))
+    {
+
+      if (nautilus_file_is_directory (file))
+	{
+	  NautilusDirectory *dir = nautilus_directory_get_for_file (file);
+	  g_object_ref (dir);
+	  if (nautilus_directory_is_in_snapshot (dir))
+	    {
+	      if (!nautilus_file_in_snap_exist_in_current (file, cancellable))
+		/* SUN_BRANDING */
+		result = g_strdup (_("not present in latest version"));
+	      else
+		/* SUN_BRANDING */
+		result = g_strdup (_("present in latest version"));
+	    }
+	  else
+	    {
+	      int version = nautilus_directory_get_num_snapshots (dir);
+
+	      if (version == 0)
+		/* SUN_BRANDING */
+		result = g_strdup (_("no version"));
+	      else
+		result = g_strdup_printf ("%d %s",version,
+					  /* SUN_BRANDING */
+					  version > 1 ? _("versions") : /* SUN_BRANDING */ _("version"));
+	    }
+	  g_object_unref (dir);
+	}
+      else
+	{
+	  if (nautilus_file_is_in_snapshot (file))
+	      result = nautilus_file_in_snapshot_get_info (file, cancellable);
+	  else
+	      result = nautilus_file_get_num_snapshot_version (file, cancellable, FALSE);
+	}
+    }
+
+/*    {
+      printf ("is %s\n", result);
+    }*/
+
+
+  qdata->return_data = restore_string (result, cancellable);
+}
+
+
+static void restore_information_ready_callback (gpointer data,
+						GCancellable *cancellable)
+{
+  QueryData *qdata = (QueryData*) data;
+  NautilusFile *file = (NautilusFile*) qdata->data;
+  char *return_data = qdata->return_data;
+
+  if (!NAUTILUS_IS_FILE (file))
+    return;
+
+  file->details->restore_info_in_progress = FALSE;
+
+  if (g_cancellable_is_cancelled (cancellable))
+    {
+      file->details->restore_info = g_strdup (_("unknown"));
+      invalidate_restore_info (file);
+      if (return_data)
+	g_free (return_data);
+    }
+  else
+    {
+      file->details->restore_info_is_up_to_date = TRUE;
+      file->details->restore_info = return_data;
+    }
+
+  nautilus_file_changed (file);
+  nautilus_file_unref (file);
+}
+
+
+static gboolean
+complete_in_idle_cb (gpointer data)
+{
+  QueryData *qdata = (QueryData*)data;
+  qdata->ready_callback (data, qdata->cancellable);
+  g_free (qdata);
+  return FALSE;
+}
+
+static void
+worker_queue_finished_callback (GObject *source_object,
+				GAsyncResult *res,
+				gpointer user_data)
+{
+  GSimpleAsyncResult *simple = G_SIMPLE_ASYNC_RESULT (res);
+  GCancellable *cancel = (GCancellable*) user_data;
+
+  worker_thread_started = FALSE;
+
+  if (g_cancellable_is_cancelled (cancel))
+    {
+      return;
+    }
+
+  g_simple_async_result_get_op_res_gpointer (simple);
+
+}
+
+static void
+worker_queue_func (GSimpleAsyncResult *res,
+		   GObject            *object,
+		   GCancellable       *cancellable)
+{
+  QueryData *data = NULL;
+
+  GTimeVal timeout;
+  GAsyncQueue *queue = (GAsyncQueue*) g_simple_async_result_get_op_res_gpointer (res);
+  g_async_queue_ref (queue);
+
+  g_get_current_time (&timeout);
+  g_time_val_add (&timeout, 3000000);
+
+  data = g_async_queue_timed_pop (queue, &timeout);
+
+  while (data)
+    {
+      GSource *source;
+
+      /* only call the worker fct if not cancel 
+       * but execute ready function anyway */
+      if (!g_cancellable_is_cancelled (data->cancellable))
+	data->worker_func (data, data->cancellable);
+
+      /*call ready callback in main loop/thread */
+      source = g_idle_source_new ();
+      g_source_set_priority (source, G_PRIORITY_DEFAULT);
+      g_source_set_callback (source, complete_in_idle_cb, data, NULL);
+      g_source_attach (source, NULL);
+      g_source_unref (source);
+
+      /* pop next one */
+      g_get_current_time (&timeout);
+      g_time_val_add (&timeout, 3000000);
+      data = g_async_queue_timed_pop (queue, &timeout);
+    }
+
+  g_async_queue_unref (queue);
+}
+
+char * nautilus_file_get_restore_info_async (NautilusFile *file)
+{
+  if (!is_time_slider_enabled ())
+    return NULL;
+
+  if (!ts_is_restore_column_enabled ())
+    return NULL;
+
+  if (file->details->restore_info_is_up_to_date)
+    {
+      /*if ( file->details->restore_info == NULL)
+	return g_strdup ("null cached info");*/
+      return g_strdup (file->details->restore_info);
+    }
+
+  if (file->details->restore_info_in_progress)
+    return g_strdup ("...");
+  else
+    {
+      static GAsyncQueue *queue = NULL;
+      QueryData *data  = NULL;
+
+      if (!file->details->directory)
+	return g_strdup ("no directory element\n");
+
+      if (!nautilus_directory_has_snapshots (file->details->directory) && !nautilus_file_is_in_snapshot (file))
+	return g_strdup ("doesn't have snap nor is in snap\n");
+
+      if (!file->details->directory->details->restore_cancel)
+	{
+	  file->details->directory->details->restore_cancel = g_cancellable_new ();
+	}
+      else
+	{
+	  if (g_cancellable_is_cancelled (file->details->directory->details->restore_cancel))
+	    return NULL;
+	}
+
+      g_free (file->details->restore_info);
+      file->details->restore_info = NULL;
+      file->details->restore_info_in_progress = TRUE;
+
+      if (!queue)
+	queue = g_async_queue_new ();
+
+      data = g_new0 (QueryData, 1);
+      data->data = file;
+      nautilus_file_ref (file);
+      data->cancellable = file->details->directory->details->restore_cancel;
+      data->ready_callback = restore_information_ready_callback;
+      data->worker_func = nautilus_file_get_restore_info;
+
+      g_async_queue_push (queue, data);
+
+      if (!worker_thread_started)
+	{
+	  GSimpleAsyncResult *res;
+	  worker_thread_started = TRUE;
+
+	  res = g_simple_async_result_new (G_OBJECT (file), 
+					   worker_queue_finished_callback, 
+					   NULL, 
+					   (gpointer) worker_queue_func);
+
+	  g_simple_async_result_set_op_res_gpointer (res, queue, NULL);
+	  g_simple_async_result_run_in_thread (res, 
+					       worker_queue_func, 
+					       G_PRIORITY_DEFAULT, 
+					       data->cancellable);
+	}
+
+      return g_strdup ("...");
+    }
+}
+
+HasSnapshotResult
+nautilus_file_has_snapshot_version (NautilusFile *file)
+{
+    if (file->details->has_snap_versions_is_up_to_date)
+        return (file->details->has_snap_versions);
+    return UNKNOWN_STATE;
+}
+
+typedef struct {
+  NautilusFile              *file;
+  GCancellable              *cancel;
+  FileHasSnapshotCallback    callback;
+  gpointer		     callback_user_data;
+  char                      *snap_dir;
+} HasSnapshotAsyncData;
+
+typedef void (*HasSnapReadyCallback) (NautilusDirectory *file,
+                                      GCancellable	*cancel,
+                                      gpointer           callback_data);
+
+
+static void has_snapshot_ready_callback (GObject *source_object,
+                                         GAsyncResult *res,
+                                         gpointer user_data)
+{
+  GSimpleAsyncResult *simple = G_SIMPLE_ASYNC_RESULT (res);
+  HasSnapshotAsyncData *data = (HasSnapshotAsyncData*) user_data;
+
+  if (g_cancellable_is_cancelled (data->cancel))
+    {
+      data->file->details->has_snap_versions_in_progress = FALSE;
+      data->file->details->has_snap_versions_is_up_to_date = FALSE;
+      if (data->file->details->snapshot_directory)
+        g_free (data->file->details->snapshot_directory);
+      
+      data->file->details->has_snapshot_cancel = NULL;
+    }
+  else
+    {
+      data->file->details->has_snap_versions_in_progress = FALSE;
+      data->file->details->has_snap_versions_is_up_to_date = TRUE;
+      if (data->file->details->snapshot_directory)
+        g_free (data->file->details->snapshot_directory);
+      data->file->details->snapshot_directory = g_simple_async_result_get_op_res_gpointer (simple);
+      if (data->file->details->snapshot_directory)
+        data->file->details->has_snap_versions = TRUE;
+      else
+        data->file->details->has_snap_versions = FALSE;
+    }
+  data->callback (data->callback_user_data);
+}
+char *
+nautilus_file_get_snapshot_dir (NautilusFile *file)
+{
+  return file->details->snapshot_directory;
+}
+void nautilus_file_real_get_snapshot_version (GSimpleAsyncResult *res,
+            				      GObject            *object,
+        				      GCancellable       *cancellable)
+{
+  NautilusFile *file = NAUTILUS_FILE (object);
+  char *snap_info = nautilus_file_get_num_snapshot_version (file, cancellable, TRUE);
+
+  if (!snap_info) /* scan for .zfs directory*/
+    snap_info = ts_get_not_zfs_snapshot_dir (nautilus_file_get_location (file));
+/*
+  {
+    struct timespec ts;
+    ts.tv_sec = 4;
+    ts.tv_nsec = 0;
+    nanosleep (&ts, NULL);
+  }
+*/
+  if (snap_info)
+    g_simple_async_result_set_op_res_gpointer (res, snap_info, (GDestroyNotify) NULL);
+  else
+    g_simple_async_result_set_op_res_gpointer (res, NULL, (GDestroyNotify) NULL);
+}
+
+void nautilus_file_get_snapshot_version (NautilusFile *file,
+                                         FileHasSnapshotCallback callback,
+                                         GCancellable *cancel,
+                                         gpointer user_data)
+{
+    HasSnapshotAsyncData *data;
+    GSimpleAsyncResult *res;
+
+    if (file->details->has_snap_versions_in_progress)
+    {
+        g_cancellable_cancel(file->details->has_snapshot_cancel);
+        file->details->has_snapshot_cancel = NULL;
+        file->details->has_snap_versions_in_progress = FALSE;        
+    }
+
+    file->details->has_snapshot_cancel = cancel;
+    file->details->has_snap_versions_in_progress = TRUE;
+    file->details->has_snap_versions_is_up_to_date  = FALSE;
+
+    data = g_new0 (HasSnapshotAsyncData, 1);
+    data->file = file;
+    data->cancel = cancel;
+    data->callback = callback;
+    data->callback_user_data = user_data;
+
+    res = g_simple_async_result_new (G_OBJECT (file),
+                                     has_snapshot_ready_callback,
+                                     data,
+                                    (gpointer) nautilus_file_real_get_snapshot_version);
+    g_simple_async_result_run_in_thread (res, nautilus_file_real_get_snapshot_version,
+                                         G_PRIORITY_DEFAULT, cancel);
+}
+
+
 void
 nautilus_file_mark_gone (NautilusFile *file)
 {
@@ -7296,6 +7992,12 @@
 	file->details->mount_is_up_to_date = FALSE;
 }
 
+static void
+invalidate_restore_info (NautilusFile *file)
+{
+        file->details->restore_info_is_up_to_date = FALSE;
+}
+
 void
 nautilus_file_invalidate_extension_info_internal (NautilusFile *file)
 {
@@ -7350,6 +8052,9 @@
 	if (REQUEST_WANTS_TYPE (request, REQUEST_THUMBNAIL)) {
 		invalidate_thumbnail (file);
 	}
+        if (REQUEST_WANTS_TYPE (request, REQUEST_RESTORE_INFO)) {
+                invalidate_restore_info (file);
+        }
 	if (REQUEST_WANTS_TYPE (request, REQUEST_MOUNT)) {
 		invalidate_mount (file);
 	}
@@ -7432,7 +8137,8 @@
 		NAUTILUS_FILE_ATTRIBUTE_LARGE_TOP_LEFT_TEXT |
 		NAUTILUS_FILE_ATTRIBUTE_EXTENSION_INFO |
 		NAUTILUS_FILE_ATTRIBUTE_THUMBNAIL |
-		NAUTILUS_FILE_ATTRIBUTE_MOUNT;
+		NAUTILUS_FILE_ATTRIBUTE_MOUNT | 
+		NAUTILUS_FILE_ATTRIBUTE_RESTORE_INFO ;
 }
 
 void
@@ -8011,6 +8717,7 @@
 	attribute_link_target_q = g_quark_from_static_string ("link_target");
 	attribute_volume_q = g_quark_from_static_string ("volume");
 	attribute_free_space_q = g_quark_from_static_string ("free_space");
+	attribute_restore_info_q = g_quark_from_static_string ("restore_info");
 	
 	G_OBJECT_CLASS (class)->finalize = finalize;
 	G_OBJECT_CLASS (class)->constructor = nautilus_file_constructor;
diff -Nrup -x '*.orig' -x '*.rej' -x '*.*~' ../SUNWgnome-file-mgr-2.30.0-b4/nautilus-2.30.1/libnautilus-private/nautilus-file.h nautilus-2.30.1/libnautilus-private/nautilus-file.h
--- ../SUNWgnome-file-mgr-2.30.0-b4/nautilus-2.30.1/libnautilus-private/nautilus-file.h	2009-12-09 12:03:51.000000000 +0100
+++ nautilus-2.30.1/libnautilus-private/nautilus-file.h	2010-05-14 17:16:39.550338308 +0200
@@ -173,6 +173,7 @@ gboolean                nautilus_file_is
 									 const char                     *mime_type);
 gboolean                nautilus_file_is_launchable                     (NautilusFile                   *file);
 gboolean                nautilus_file_is_symbolic_link                  (NautilusFile                   *file);
+gboolean                nautilus_file_is_in_snapshot			(NautilusFile                   *file);
 gboolean                nautilus_file_is_mountpoint                     (NautilusFile                   *file);
 GMount *                nautilus_file_get_mount                         (NautilusFile                   *file);
 char *                  nautilus_file_get_volume_free_space             (NautilusFile                   *file);
@@ -228,6 +229,26 @@ char *                  nautilus_file_ge
 
 NautilusFile *          nautilus_file_get_trash_original_file           (NautilusFile                   *file);
 
+char *			nautilus_file_get_num_snapshot_version		(NautilusFile			*file,
+									 GCancellable			*cancel,
+                                                                         gboolean                        stop_at_first);
+char *			nautilus_file_get_restore_info_async		(NautilusFile			*file);
+
+typedef enum {
+	NO,
+	YES,
+	UNKNOWN_STATE
+} HasSnapshotResult;
+
+HasSnapshotResult       nautilus_file_has_snapshot_version              (NautilusFile                   *file);
+char *                  nautilus_file_get_snapshot_dir                  (NautilusFile                   *file);
+typedef void (*FileHasSnapshotCallback)	(gpointer user_data);
+
+void                    nautilus_file_get_snapshot_version              (NautilusFile                   *file,
+                                                                         FileHasSnapshotCallback        callback,
+                                                                         GCancellable *cancel,
+                                                                         gpointer                       user_data);
+
 /* Permissions. */
 gboolean                nautilus_file_can_get_permissions               (NautilusFile                   *file);
 gboolean                nautilus_file_can_set_permissions               (NautilusFile                   *file);
--- nautilus-3.1.3/libnautilus-private/nautilus-global-preferences.h.orig	2011-07-22 10:33:34.400109504 +0100
+++ nautilus-3.1.3/libnautilus-private/nautilus-global-preferences.h	2011-07-22 10:37:38.055064000 +0100
@@ -42,6 +42,7 @@
 #define NAUTILUS_PREFERENCES_SHOW_HIDDEN_FILES			"show-hidden-files"
 #define NAUTILUS_PREFERENCES_SHOW_ADVANCED_PERMISSIONS		"show-advanced-permissions"
 #define NAUTILUS_PREFERENCES_DATE_FORMAT			"date-format"
+#define NAUTILUS_PREFERENCES_ENABLE_TIME_SLIDER			"enable-time-slider"
 
 /* Mouse */
 #define NAUTILUS_PREFERENCES_MOUSE_USE_EXTRA_BUTTONS		"mouse-use-extra-buttons"
